#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "context_grep.c"


/*
 * used for testing
 */
 void
main(int argc, char **argv)
{
	char *test_strs[] = {
		"Hello world",
		"Welcome to California",
		"Goodbye",
		"Big sky",
		"Nice job",
		"Blue sky",
		"Hey Joe",
		NULL
	};


	printf("test 1: zero length expression string\n");
	printf("there should be no output or segv\n");
	context_grep(7, test_strs, 2, "");

	printf("=====================================================\n");
	printf("test 2: expression string argument = NULL\n");
	printf("there should be no output or segv\n");
	context_grep(7, test_strs, 2, NULL);

	printf("=====================================================\n");
	printf("test 3: argv is NULL\n");
	printf("there should be no output or segv\n");
	context_grep(7, NULL, 2, "sky");

	printf("=====================================================\n");
	printf("test 4: argc is too large (string array has null at the end)\n");
	printf("output should consist of 6 strings, but no segv\n");
	context_grep(10, test_strs, 2, "sky");
}
